/*************************************************************************/
/***             Adapt these definitions to your system                ***/
/*************************************************************************/


/*-----------------------------------*/
/*---    Operating system         ---*/
/*-----------------------------------*/

#define UNIX	/* On non-Unix systems comment this line */


/*-----------------------------------*/
/*---    'const' keyword          ---*/
/*-----------------------------------*/

/*  If your compiler complains about 'const', undefine this macro */
/* It must be defined in an ANSI compiler */
/* #define CONSTANT	/**/


/*-----------------------------------*/
/*---    Directory functions      ---*/
/*-----------------------------------*/
/* If you do not have any functions for directory management */
/* #define NO_DIR_FUNCTIONS	/**/

#define DIRENT		/*  This or...  */
/* #define DIRECT	/*  ...this     */


/*-----------------------------------*/
/*---    Random number generation ---*/
/*-----------------------------------*/

/* If your system does not have the function 'random()'	*/
#define RANDOM_SRC	/**/


/*************************************************************************/
/*************** END OF USER'S DEFINITIONS *******************************/
/*************************************************************************/

/*  The loop identifier for the help function  */
#define MENU_MAIN		0
#define MENU_CLASSIFIER		1
#define MENU_FEATSEL_SEARCH	2
#define MENU_FEATEXTRACT	3
#define MENU_MISC		4
#define MENU_INTFACE		5
#define MENU_LVQ		6
#define MENU_SNNS		7
#define MENU_CROSSVAL		8
#define MENU_NORM		9
#define MENU_FEATSEL_CRIT_GROUP	10


#define MAX(a,b)		(a<b ? b : a)
#define MIN(a,b)		(a>b ? b : a)
#define SGN(x)			(x>=0 ? 1 : -1)

#define TRUE 1
#define FALSE 0

#define EMPTY (-1)

/* open, closed intervals */
#define LEFT_CLOSED__RIGHT_CLOSED	0
#define LEFT_CLOSED__RIGHT_OPEN		1
#define LEFT_OPEN__RIGHT_CLOSED		2
#define LEFT_OPEN__RIGHT_OPEN		3

#ifdef NON_UNIX
#define f_open_bin_w "wb"
#define f_open_bin_r "rb"
#define f_open_text_w "w"
#define f_open_text_r "r"
#else
#define f_open_bin_w "w"
#define f_open_bin_r "r"
#define f_open_text_w "w"
#define f_open_text_r "r"
#endif

#define NL  printf("\n")
#define DBG  {char _str[81];printf("...");gets(_str);}
#define WAIT  {char _str[81];printf("...");gets(_str);}
#define EXIT(msgStr) {fprintf(stderr,"\n%s\nExitus...\n",msgStr);exit(1);}
#define BLANK_LINE \
        {int i;printf("\r");for(i=0;i<79;i++)printf(" ");printf("\r");}

#define FREE(ptr) if(ptr!=NULL){free(ptr);ptr=NULL;}
#define CHKPTR(ptr) if(ptr==NULL){fprintf(stderr,"\n\nAllocation problem \
with 'ptr' - exitus...\n");exit(1);}

typedef char str20[21];
typedef char str30[31];
typedef char str50[51];
typedef char str80[81];
typedef char str100[101];
typedef char str200[201];
typedef int boolean;
typedef unsigned char byte;

#define INFINITY (1000000000000.0)

#define MAXCLASS 1000
#define MAXFEAT 10000

typedef float *FeatVector;

typedef struct feature_ {
          int rank;		/* selected as the ? best */
          float crit;		/* selection criterion */
        } feature, *FeatSelectVector;

typedef struct statistics_ {
	FeatVector min, max;  /* minimum and maximum values of features */
	FeatVector mean, stddev;  /* mean and standard deviation */
	} statistics;

typedef struct Clas_ {
          str100 name;			/* name of the class */
          int numSampl;			/* how many samples for this class */
          FeatVector S;			/* all samples for this class */
	  statistics stat;		/* class specific statistics */
          float a_priori_prob;		/* a priori probability of the class */
        } Clas,  *Classes;

typedef struct universe_ {
          str100 name;		/* name of the universe */
          int nrClass;		/* How many classes	*/
          int sumSampl;		/* The number of all samples of all classes */
          int nrFeat;		/* How many features are used	*/
	  statistics stat;	/* global statistics */
          int nrSelFeat;	/* How many selected features */
          FeatSelectVector FSV;	/* Pointer to selected features */
          Classes C;		/* Pointer to the classes */
        } universe;
