/************************************************************************
 *                                                                      *
 *  Program package         T O O L D I A G                             *
 *                                                                      *
 *  Version 2.1.1                                                       *
 *  Date:     Thu Sep 17 11:44:22 1998                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'thomas@inf.ufes.br'.                                *
 *                                                                      *
 ************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "def.h"

#ifndef NO_DIR_FUNCTIONS

#ifdef DIRECT
#undef DIRENT
#endif

#ifdef DIRENT
#include <dirent.h>
static struct dirent *dp = NULL;
#endif
#ifdef DIRECT
#include <sys/dir.h>
static struct direct *dp = NULL;
#endif

static DIR *dir = NULL;
#endif


boolean open_directory( inDataDir )
char *inDataDir;
{
#ifndef NO_DIR_FUNCTIONS
 dir = opendir( inDataDir );
 if( dir != NULL )
   return( TRUE );
#endif
#ifdef NO_DIR_FUNCTIONS
 fprintf(stderr, "No directory functions available!\n"); WAIT;
 return( FALSE );
#endif
}


void close_directory()
{
#ifndef NO_DIR_FUNCTIONS
 int ret;
 /*
  The closedir subroutine closes a directory stream and frees the
  structure associated with the DirectoryPointer parameter.
 */

 ret = closedir( dir );
 if( ret != 0 )
 {
   fprintf(stderr,"close_directory> Had bad return = %d", ret );
   exit(1);
 }
 dir = NULL;
#endif
}

/* Check if something is a directory or a file */
boolean is_directory( name )
char *name;
{
 boolean ok = FALSE;

#ifndef NO_DIR_FUNCTIONS
 ok = open_directory( name );
 if( ok )
   close_directory();

#endif
 return( ok );
}


boolean err_directory()
{
#ifndef NO_DIR_FUNCTIONS
 return( dir == NULL );
#endif
#ifdef NO_DIR_FUNCTIONS
 return( FALSE );
#endif
}


boolean next_directory( dirName, fileName )
char *dirName;	/* here without function */
char *fileName;
{
#ifndef NO_DIR_FUNCTIONS
 do
 {
   dp = readdir( dir );
   if( dp == NULL )
     return( FALSE );
 }
 while( dp->d_name[0]=='.' || (dp->d_name[0]=='.' && dp->d_name[1]=='.') );
 strcpy( fileName, dp->d_name );
#endif
 return( TRUE ); 
#ifdef NO_DIR_FUNCTIONS
 return( FALSE );
#endif
}
