/************************************************************************/
/***** EUCLIDEAN DISTANCES BETWEEN 2 SAMPLES USING SCATTER MATRICES *****/
/* see pp. 235 f. */
/************************************************************************/
#define J1 0
#define J2 1
#define J3 2
#define J4 3

#define NUM_EUCLID_DISTANCES 4


/***************************************/
/*****  SELECTION CRITERIA GROUPS  *****/
/***************************************/
#define MIN_EST_ERR 0
#define INTER_CLASS_DISTANCE 1		/* see pp. 229 */
#define PROBABILISTIC_DISTANCE 2

#define NUM_SEL_CRIT_GROUPS 3


/*#####################################################*/
/*#####      S E L E C T I O N  C R I T E R I A     ###*/
/*#####################################################*/

/*******************************************************/
/***** INTERCLASS DISTANCE SELECTION CRITERIA      *****/
/* see pp. 232 */
/*******************************************************/
#define MINKOWSKI			0
#define CITY_BLOCK			1
#define EUCLIDEAN			2
#define CHEBYCHEV_DIST			3
#define NONLINEAR			4

#define NUM_DISTANCES 5


/**************************************************************/
/*****     PROBABILISTIC DISTANCE SELECTION CRITERIA      *****/
/**************************************************************/
#define CHERNOFF			0
#define BHATTACHARYYA			1
#define BHATTACHARYYA_MATUSITA		2
#define DIVERGENCE			3
#define MAHALANOBIS			4
#define PATRICK_FISHER			5
#define NORMMEANDIST			6

#define NUM_PROB_DIST_CRITERIA 7



/***************************************/
/*****      SEARCH STRATEGIES      *****/
/***************************************/
#define BF 0
#define SFS 1
#define SBS 2
#define B_AND_B 3
#define EXHAUSTIVE 4

#define NUM_STRATEGIES 5
