/************************************************************************
 *                                                                      *
 *  Program package         T O O L D I A G                             *
 *                                                                      *
 *  Version 2.1.1                                                       *
 *  Date:     Thu Sep 17 11:44:30 1998                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'thomas@inf.ufes.br'.                                *
 *                                                                      *
 ************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "def.h"

extern universe *U;
extern boolean verbose;
extern str100 outDataDir;
extern boolean feat_description;
extern char **feature_desc;



static str80 name, polyFile;
static str100 efn;	/* extracted features names *

/*
  Feature Extraction based on
  Higher-order combinations of features
*/

static void save_poly_extr_feat_names( dim, newdim )
int dim, newdim;
{
 int k, l;
 FILE *fn = NULL;
 
 if( ! feat_description ) return;

 strcpy( efn, outDataDir );
 printf("Saving the names of the extracted features to:\n\t%s", efn );
 gets( name );
 if( name[0] != '\0' )
 {
   strcat( efn, name );
   fn = fopen( efn, f_open_text_w );
   if( fn == NULL )
     { printf("Cannot open %s for writing! Exitus...\n", efn ); exit(1); }
 
   fprintf( fn,"#\n# Extracted features from universe: %s\n# Filename: %s\n#\n",
		U->name, name );
   fprintf( fn, "%d\n", newdim );


   for( k = 0; k < dim; k++ )
     fprintf( fn, "%s\n", feature_desc[k] );
   for( k = 0; k < dim; k++ )
     for( l = k; l < dim; l++ )
       fprintf( fn, "%s*%s\n", feature_desc[k], feature_desc[l] );

   fclose( fn );
 }
 else
   printf("\tNothing saved...\n");
}


void featExtrPOLY()
{
 int i, j, k, l;
 int dim, newdim;
 FILE *poly = NULL;
 float xk, xl;

 dim = U->nrFeat;
 newdim = dim + dim + (dim*dim-dim)/2;

 printf("\n  --- FEATURE EXTRACTION BASED ON ---\n");
 printf("      HIGHER ORDER COMBINATIONS    \n\n");
 NL;
 printf("From %d features generating the full quadratic set of %d features\n",
	dim, newdim );

 strcpy( polyFile, outDataDir );
 printf("Saving the extracted data in LVQ_PAK format in file:\n\t\t%s",
		polyFile ); gets( name );

 if( name[0] == '\0' )
     { printf("Nothing saved...\n"); return; }

 strcat( polyFile, name );
 poly = fopen( polyFile, f_open_text_w );
 if( poly == NULL )
   { printf("Cannot open %s! Exitus...\n", polyFile ); exit(1); }
 if( verbose )
   printf("Generating file: %s\n", polyFile );

 fprintf( poly, "%d\n", newdim );
 for( i = 0; i < U->nrClass; i++ )
 {
   for( j = 0; j < U->C[i].numSampl; j++ )
   {
     /* First the original features */
     for( k = 0; k < dim; k++ )
       fprintf( poly, "%f ", (float)U->C[i].S[j*dim+k] );

     /* Now the full quadratic set */
     for( k = 0; k < dim; k++ )
       for( l = k; l < dim; l++ )
       {
         xk = (float)U->C[i].S[j*dim+k];
         xl = (float)U->C[i].S[j*dim+l];
         /* generate the quadratic term */
         fprintf( poly, "%f ", xk * xl );
       }
     fprintf( poly, "%s\n", U->C[i].name );
   }
 }
 fclose( poly );
 printf("  ...done.\n");
 save_poly_extr_feat_names( dim, newdim );
}
