/************************************************************************
 *                                                                      *
 *  Program package         T O O L D I A G                             *
 *                                                                      *
 *  Version 2.1.1                                                       *
 *  Date:     Thu Sep 17 11:44:25 1998                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'thomas@inf.ufes.br'.                                *
 *                                                                      *
 ************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "def.h"


extern str100 rootDataDir;


static str80 buf;
static str100 hlpFileNam, linebuf;
#define TOOLDIAG_HELP_FILE "tooldiag.hlp"
static FILE *hf = NULL;
#define MAX_TOPIC_BUF 10000

static char helpChar = '$';
static char bibRefChar = '[';

#define LEN 100

/*
 * Try to find the topic "item" in the helpfile
*/
static void help_topic( item, itemChar )
char *item, itemChar;
{
 boolean found, endTopic; int c, tp; char ch;
 str80 hlpItem;
 char *topic_buf = NULL;

 topic_buf = (char*) malloc( MAX_TOPIC_BUF * sizeof(char) ); CHKPTR(topic_buf);

 strcpy( hlpFileNam, rootDataDir );
 strcat( hlpFileNam, TOOLDIAG_HELP_FILE );
 hf = fopen( hlpFileNam, f_open_text_r );
 if( hf == NULL )
   {printf("Sorry, cannot open help file %s! ...",hlpFileNam);gets(buf);return;}

 /* search for the item in the file */
 /* printf("item=>>>%s<<<\n", item ); DBG; /**/
 found = FALSE;
 while( !feof( hf ) && !found )
 {
   fgets( linebuf, LEN, hf );
   /* printf("linebuf=>>>%s<<<\n", linebuf ); DBG; /**/
   if( !feof( hf ) && linebuf[0] == itemChar )
   {
     sscanf( &(linebuf[1]), "%s", hlpItem );
     found = (strncmp(hlpItem,item,strlen(item))==0);
     /* printf("found=%d...", found ); DBG; /**/
   }
 }
 if( found )
 {
   /* read all text until end-of-file or blank line */
   endTopic = FALSE; tp = 0; topic_buf[0] = '\0';
   while( !endTopic && tp < MAX_TOPIC_BUF )
   {
     c = fgetc( hf ); ch = (char)c;
     endTopic = feof( hf ) || ch == itemChar;
     topic_buf[ tp ] = ch; tp++;
   }
   topic_buf[ tp ] = '\0';
   if( ch == itemChar ) topic_buf[ tp-1 ] = '\0';
   /* printf("topic_buf=>>>%s<<<", topic_buf ); DBG; /**/
   printf("%s", topic_buf );
 }
 else
 {
   fprintf(stderr,"HELP: Could not find topic %s\n", item );
 }
 fclose( hf );
 FREE(topic_buf);
}


void item_help( item )
char *item;
{
 printf("\n------------------------   H E L P    ------------------------\n");
 help_topic( item, helpChar ); 
}


void item_bibRef( item )
char *item;
{
 printf("\n------   B I B L I O G R A P H I C  R E F E R E N C E   ------\n");
 help_topic( item, bibRefChar ); 
}


void help( loop, cmd )
int loop;
char *cmd;
{
 switch( loop )
 {
   case MENU_MAIN: helpMENU_MAIN( cmd ); break;
   case MENU_CLASSIFIER: helpMENU_CLASSIFIER( cmd ); break;
   case MENU_FEATSEL_SEARCH: helpMENU_FEATSEL_SEARCH( cmd ); break;
   case MENU_FEATEXTRACT: helpMENU_FEATEXTRACT( cmd ); break;
   case MENU_MISC: helpMENU_MISC( cmd ); break;
   case MENU_INTFACE: helpMENU_INTFACE( cmd ); break;
   case MENU_LVQ: helpMENU_LVQ( cmd ); break;
   case MENU_SNNS: helpMENU_SNNS( cmd ); break;
   case MENU_CROSSVAL: helpMENU_CROSSVAL( cmd ); break;
   case MENU_NORM: helpMENU_NORM( cmd ); break;
   case MENU_FEATSEL_CRIT_GROUP: helpMENU_FEATSEL_CRIT_GROUP( cmd ); break;
   default: fprintf( stderr, "help> unknown menu mode..."); gets( buf ); break;
 }
 WAIT;
}
