/************************************************************************
 *                                                                      *
 *  Program package         T O O L D I A G                             *
 *                                                                      *
 *  Version 2.1.1                                                       *
 *  Date:     Thu Sep 17 11:44:26 1998                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'thomas@inf.ufes.br'.                                *
 *                                                                      *
 ************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include "def.h"

extern universe *U;


static str80 buf;
static boolean done;
static int menuItem = EMPTY;


/***************************************/
/*****     MENU ITEMS              *****/
/***************************************/

/*   -----   MISCELLANEOUS MENU    -----        */
#define CORRELAT        0
#define DEMO            1
#define STATS		2
#define ADD_NOISE	3

#define NUM_MISCMENU_ITEMS 4


static struct miscMenuItems {
        int index;
        str80 name;
} miscMenuItem[] = {
	{ CORRELAT,	"Linear correlation between 2 features" },
	{ DEMO,		"Batch demo" },
	{ STATS,  "Generate and display statistical parameters of universe" },
	{ ADD_NOISE,  "Add white Gaussian noise to the features" }
};


static void batch()
{
 while( U->nrClass == 0 )
 {
   printf("--- LOADING:\n");
   loadUniv();
   showUniv( stdout );
 }
 featSelectDEMO();
 showUniv( stdout );
 printf("--- ERROR ESTIMATION USING NEAREST NEIGHBOR FOR FEATURES SEQUENCE:\n");
 est_err_nearneib(); /**/
 printf("--- SAMMON PLOT:\n");
 sammon_plot();
 printf("--- LEARNING WITH Q*:\n");
 induceDEMO();
}



static void execMenuItem()
{
 switch( menuItem )
 {
   case CORRELAT:	correlation(); break;
   case DEMO:		batch(); break;
   case STATS:		drop_stat_param(); break;
   case ADD_NOISE:	add_white_noise(); break;
   default: fprintf(stderr,"What the heck is item %d? - exit...\n", menuItem );
 }
}

static char sl[] =
     "-----------------";


void miscMain()
{
 int i, d; char *str = NULL;

 done = FALSE;
 do
 {
   printf("\n%s  M I S C E L L A N E O U S   %s\n", sl, sl );
   for( i = 0; i < NUM_MISCMENU_ITEMS; i++ )
   {
     str = miscMenuItem[i].name;
     printf("(%d)\t%s\n", i+1, str );
   }

   printf("Choice: "); gets(buf);
   switch( buf[0] )
   {
     /* special cases */
     case '?': help( MENU_MISC, buf ); break;
     case '\0': done = TRUE; showUniv( stdout ); break;
     default:
       sscanf(buf,"%d", &d);
       if( d >= 1 && d <= NUM_MISCMENU_ITEMS )
       {
         menuItem = d-1;
         execMenuItem();
       }
   }
 }
 while( ! done );
}


/**********  H E L P  *****************/

void helpMENU_MISC( cmd )
char *cmd;
{
 int item;

 sscanf( &(cmd[1]), "%d", &item );
 item--;	/* discount one since in the menu it is one more */
 switch( item )
 {
   case CORRELAT: item_help("CORRELAT"); break;
   case DEMO: item_help("DEMO"); break;
   case STATS: item_help("STATS"); break;
   case ADD_NOISE: item_help("ADD_NOISE"); break;
   default: ; break;
 }
}
