/************************************************************************
 *                                                                      *
 *  Program package         T O O L D I A G                             *
 *                                                                      *
 *  Version 2.1.1                                                       *
 *  Date:     Thu Sep 17 11:44:31 1998                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'thomas@inf.ufes.br'.                                *
 *                                                                      *
 ************************************************************************/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "def.h"

extern universe *U;

#define PMAX (1000.0)


static char sl[] = "-----------------";
static boolean verbose = FALSE, trace = FALSE;


static void add_unit_noise_smp( i, c, smp, dim, absolute_noise )
int i, c;
FeatVector smp;
int dim;
float absolute_noise;
{
 int k;
 float r;


 if( verbose )
 {
   printf("Before adding noise: Sample # %d of class %d(%s)\n\t\t\t",
	i+1, c+1, U->C[c].name );
   showFV( dim, smp );
 }
 for( k = 0; k < dim; k++ )
 {
   get_zeroMean_sigmaStddev_noise( absolute_noise, &r );
   smp[k] += r;
   /* printf("smp[%3d] = %f + %f = %f", k, smp[k], r, smp[k]+r ); DBG;	/**/
 }
 if( verbose )
 {
   printf("After adding noise: \t" );
   showFV( dim, smp );
   if( trace ) WAIT else NL;
 }
}


void add_white_noise()
{
 float absolute_noise;
 int i, c;

 printf("\n%s  A D D I N G  W H I T E  N O I S E   %s\n", sl, sl );
 printf("Standard deviation of noise: ");
 get_f_range( &absolute_noise, 0.0, PMAX, LEFT_OPEN__RIGHT_CLOSED); 
 printf("Verbose the noise adding?");
 get_boolean( verbose, &verbose );
 if( verbose )
 {
   printf("Trace the noise adding for each sample?");
   get_boolean( trace, &trace );
 }
 
 for( c = 0; c < U->nrClass; c++ )
   for( i = 0; i < U->C[c].numSampl; i++ )
     add_unit_noise_smp( i, c, &(U->C[c].S[i*U->nrFeat]),
		U->nrFeat, absolute_noise );


 /* Update statistical information */
 generate_stats( FALSE );
}
